<?php
/*
*
*		Helper for DB connections
*
*/

// must be run within Dokuwiki
if (!defined('DOKU_INC')) die();

if (!defined('DOKU_LF')) define('DOKU_LF', "\n");
if (!defined('DOKU_TAB')) define('DOKU_TAB', "\t");
if (!defined('DOKU_PLUGIN')) define('DOKU_PLUGIN',DOKU_INC.'lib/plugins/');

class helper_plugin_indieplus_dbhelper extends DokuWiki_Plugin {

     function _sqlaccess($Server,$User,$Pass,$Database,$Query){
 
        if(!$connection = odbc_connect("DRIVER={Microsoft Access Driver (*.mdb)}; DBQ=$Database", "ADODB.Connection", $Pass, "SQL_CUR_USE_ODBC") or false) {
          	throw new Exception($this->aString["problem"]);
        }
 
        $rs = odbc_exec($connection,$Query);
 
        $dbArray = array();
        while ($row = odbc_fetch_array($rs))
          $dbArray[] = $row;
 
        odbc_close($connection);
        return $dbArray;
 
    }
     function _postgresql($Server,$User,$Pass,$Database,$Query){
 
        if(!$connection = pg_connect("host=".$Server." dbname=".$Database." user=".$User." password=".$Pass) or false)
          throw new Exception($this->aString["problem"]);
 
        $rs = pg_exec($Query);
        $dbArray = pg_fetch_array($result, NULL, PGSQL_ASSOC);
 
        pg_close($connection);
        return $dbArray;
 
    }
 
     function _mysql($Server,$User,$Pass,$Database,$Query){
 
        if(!$connection = mysql_connect($Server, $User, $Pass) or false)
          throw new Exception(mysql_error());
 
        mysql_select_db($Database, $connection);
error_log("_mysql query = ".$Query); 
        $rs = mysql_query($Query);
        $dbArray = array();
error_log("_mysql rs = ".$rs); 
        if($rs === true) {
          $dbArray[] = array( $this->aString["affected"] => mysql_affected_rows ($connection));
        } else if ($rs === false) {
        	// return empty array	
        } else {
          while ($row = mysql_fetch_assoc($rs)) {
            $dbArray[] = $row;
          }
        }
 
 
        mysql_close($connection);
        return $dbArray;
 
    }
     function _mssql($Server,$User,$Pass,$Database,$Query){
 
        if(!$dbhandle = mssql_connect($Server, $User, $Pass)) 
          throw new Exception($this->aString["problem"]);
 
        mssql_select_db($Database, $dbhandle);
 
        $rs = mssql_query($Query);
 
        $dbArray = array();
 
        if($rs === true)
          $dbArray[] = array( $this->aString["affected"] => mssql_rows_affected ($connection));
        else
          while ($row = mssql_fetch_assoc($rs))
            $dbArray[] = $row;
 
        mssql_close($dbhandle);
        return $dbArray;
 
    }
 
     function _oracle($Server,$User,$Pass,$Database,$Query){
          throw new Exception($this->aString["nohandler"]);      
    }
 
     function _sqlcsv($Server,$User,$Pass,$Database,$Query){  
 
        if(!$handle = fopen($Database,"r"))
          throw new Exception($this->aString["nohandler"]);    
 
        $dbArray = array();
        $keys = fgetcsv ( $handle , 1000, $Query);
 
        while ($row = fgetcsv ( $handle , 1000, $Query)){
          $temprow = array();
          foreach($row as $key => $value)
            $temprow[$keys[$key]] = $value;
 
          $dbArray[] = $temprow;
 
        }
 
        fclose($handle);
        return $dbArray;
 
    }
 
     function _sqlite($Server,$User,$Pass,$Database,$Query){
 
        $dbHandle = new PDO('sqlite:'.$Database);    
 
        $result = $dbHandle->query($Query);
        if(!$result)
          throw new PDOException;
        $dbArray = array();
 
        if($result->rowCount() > 0)
          $dbArray[] = array( $this->aString["affected"] => $result->rowCount() );
        else
          while($row = $result->fetch(PDO::FETCH_ASSOC))
            $dbArray[] = $row;
 
        return $dbArray;
 
    }
}

?>