#!/usr/bin/php
<?php
/**
 * Google+ Invited data capture
 *
 * Based on code from - http://www.splitbrain.org/blog/2007-03/01-mobile_blogging_with_dokuwiki
 */

ini_set('display_errors', 'On');
error_reporting(E_ALL);

$doubleNL = chr(10).chr(10);

if ('cli' != php_sapi_name()) die(99);

if(!defined('DOKU_INC')) define('DOKU_INC','/var/www/indieplus.org/');

// NOTE that init.php will silently fail if this script does not have write rights on the 
// relevent directories

require_once DOKU_INC.'inc/init.php';

require_once DOKU_INC.'inc/common.php';

require_once 'mime_parser.php';



$crlf = chr(13).chr(10);


// read the mail and parse it
$data = array();
$mail = new mime_parser_class();

$ok = $mail->Decode(array('File' => 'php://stdin'), $data);

if(!$ok) {
	error_log("Indieplus.org MAIL2PAGE - decoding failed".$doubleNL, 3, "/var/tmp/mail2page.error.log"); 
	die(1);
}

$data = $data[0];

#print_r($data);

//error_log("mail2page LOADED");
//error_log(var_export($data,1));

// set up the reporting address
$from = m2p_getHeader($data,array('reply-to:','from:'));


// Check mail is from Google+
if ( preg_match("/@plus.google.com/", $from) == 0 ) {
	error_log("Indieplus.org MAIL2PAGE - Not from Google+".$doubleNL, 3, "/var/tmp/mail2page.error.log"); 
	die(2);

}



// check the parts
if(count($data['Parts']) == 0){

    if(substr($data['Headers']['content-type:'],0,10) != 'text/plain'){
        m2p_finish('bad content type - we can only handle text/plain');
    }
//    m2p_handlePage($data['Body'], $data['Headers']['content-type:']);

	// What ever this message is it is not conforming to the standard Google+ message format
	error_log("Indieplus.org MAIL2PAGE - Unexpect structure to email".$doubleNL, 3, "/var/tmp/mail2page.error.log"); 
	die(3);
}else{

   
    if ( count($data['Parts']) != 2 ) {
		error_log("Indieplus.org MAIL2PAGE - Too many parts to email".$doubleNL, 3, "/var/tmp/mail2page.error.log"); 
		die(4);
    }

	$part_text = $data['Parts'][0];
	$part_html = $data['Parts'][1];
	
	
	if ( substr($part_text['Headers']['content-type:'],0,10) != 'text/plain' ) {
		error_log("Indieplus.org MAIL2PAGE - Part text not plain text".$doubleNL, 3, "/var/tmp/mail2page.error.log"); 
		die(5);
	} else {
		$messageType = indieplusProcessText($part_text['Body']);
	}


	if ( substr($part_html['Headers']['content-type:'],0,9) != 'text/html' ) {
		error_log("Indieplus.org MAIL2PAGE - Part html not html".$doubleNL	, 3, "/var/tmp/mail2page.error.log"); 
		die(6);	
	} else {
		$htmlArray = indieplusProcessHTML($part_html['Body'], $messageType);
	}

	$ID = ":events:indie2:".$htmlArray['eventid'];	// Make it unique
	switch ($messageType) {
		case 1:
			// New
			insertdata($htmlArray);
			addPage($ID, $htmlArray);
			m2p_finish($htmlArray);
			break;
		case 2:
			// Change
			updateData($htmlArray);
			break;
		case 4: 
			// Cancel
			break;
		default:	
			error_log("Indieplus.org MAIL2PAGE - Unexpected Message Type".$doubleNL, 3, "/var/tmp/mail2page.error.log"); 
			die(10);
			break;
	}
	
	
	// Note, this creates files with the wrong user prival
//    saveWikiText($ID,createPageContent($htmlArray),'Autogenerated via Email Notification');  



	die();


}


/**
 * Convert the body charset and save the page
 */
function m2p_handlePage(&$body,$ctype){
    global $ID;

    static $run = false;
    if($run){
        return;
    }
    $run = true;


    if(preg_match('/charset=["\']?([^"\']+)["\';]?$/i',$ctype,$match)){
        $body = iconv($match[1],'utf-8',$body);
    }

    $body = cleanText($body);
    //strip signature:
    $body = preg_replace('/\n?-- (.*)$/s','',$body);

	return $body;
}

/**
 * Get a (maybe decoded) header from any of the given fields
 */
function m2p_getHeader(&$data,$headers){
    if(!is_array($headers)) $headers = array($headers);

    $value = '';
    foreach($headers as $header){
        if($data['DecodedHeaders'][$header][0][0]['Value']){
            $value = iconv($data['DecodedHeaders'][$header][0][0]['Encoding'],
                    'utf-8', $data['DecodedHeaders'][$header][0][0]['Value']);
            break;
        }
        if($data['Headers'][$header]){
            $value = $data['Headers'][$header];
            break;
        }
    }
    return $value;
}

/**
 * Send a report back and end the script
 *
 * If $message is set it is added to the report before sending it.
 */
function m2p_finish($data){
	global $doubleNL;
	
	$to = "chris@6d6fireball.com";
	$from = "do-not-replay@indieplus.org";
	
	$subject = '"'.$data['eventname'] .'" created in wiki ';
	
	$body = "The following data was data to IndiePlus.org ".$doubleNL;
	foreach ($data as $key=>$value) {
		$body .= $key." : ".$value.$doubleNL;	
	}

    mail_send($to, $subject, $body, $from);
    exit();
}


function indieplusProcessText( $body ) {
	// Workout what type of email notificaton it is
	
	global $doubleNL;

	$messageType = -1;
	
    $body = cleanText($body);


	$body = htmlentities($body);

	$newMatchString = '/(.*) invited you to .*&quot;(.*)&quot;.*\n(.*)\n(.*) invited.*\n(.*)/s';
	$changeMatchString = '/(.*) changed the event time to(.*)/s';
	$deleteMatchString = '/(.*) XXXX (.*)/s';
error_log("Indieplus.org MAIL2PAGE - ".$body.$doubleNL, 3, "/var/tmp/mail2page.error.log"); 

	if ( preg_match( $newMatchString, $body, $matches) ) {
	
		$messageType = 1;  // New Event
/*		$data = array( "eventname" => $matches[2],
			"datetime" => $matches[3],
			"eventdiscription" => $matches[5],
			"eventhostname" => $matches[1]
			); 
*/
	}  else if ( preg_match( $changeMatchString, $body, $matches) ) {
		$messageType = 2;	
	}  else if ( preg_match(	$deleteMatchString, $body, $matches) ) {
		$messageType = 4;
	}
	// Tidy the text, just to make it easier to read on the wiki
//	$rValue = preg_replace('/\n/', $doubleNL, $body);
	
	
//	$rValue.= $doubleNL."----".$doubleNL.var_export($data,1);	
	
	return $messageType;	
}

function indieplusProcessHTML( $body, $messageType ) {
	global $doubleNL;
	
	$rValue = NULL;
	
	switch ( $messageType ) {
		case 1:
			// New Notifcation
			$rValue = newNotification( $body );
			break;
		case 2:
			// Change
			$rValue = changeNotification( $body ); 
			break;
		case 3:
			// Cancel
			// break;
		default:
			error_log("Indieplus.org MAIL2PAGE - Message Type not Identified".$doubleNL, 3, "/var/tmp/mail2page.error.log"); 
			die(7);
	}
	
	return $rValue;
}
function newNotification( $body ) { 
	global $doubleNL;
	
	$data = array();
	

	// Get the text elements. 
	$dateMatch = '!(Today|Mon|Tue|Wed|Thu|Fri|Sat|Sun), [0-9]{1,2} [A-Z][a-z]*, [0-9]{2}:[0-9]{2} [A-Za-z]*!';
	preg_match( $dateMatch,$body, $match );
	$data["datetime"] = $match[0];

	$descMatch = "!invited</td></tr></table>(.*)</td></tr></table>!s";
	preg_match( $descMatch,$body, $match );

//error_log("AAAA".$match[1].$doubleNL, 3, "/var/tmp/mail2page.error.log"); 

//	$data["eventdescription"] = preg_replace("!<br>!s",$doubleNL, $match[1]);
//error_log("XXXX".$data["eventdescription"].$doubleNL, 3, "/var/tmp/mail2page.error.log"); 

//	$data["eventdescription"] = htmlentities($data["eventdescription"]);	

	$data["eventdescription"] = str_replace(chr(160)," ", $match[1]);



//die($data["eventdescription"]);

	// Now the elements that are hyperlinked
	$linksMatch = '!<a[^>]*href="(.*?)".*?>(.*?)</a>!';
	preg_match_all( $linksMatch,$body, $match );

	$data["eventhostname"] = $match[2][2];	
	$data["eventname"] = $match[2][3];
	$data["hostprofileurl"] = $match[1][2];	
	$data["eventlink"] = $match[1][3];

	// URLS need tweaking to be useful
	$eventPathMatch = '!path=%2Fevents%2F(.*?)%!';
	preg_match($eventPathMatch, $data["eventlink"], $matches);
	$data["eventid"] = $matches[1];
	$data["eventlink"] = 'https://plus.google.com/u/0/events/'.$data["eventid"];

	$pathMatch = '!path=%2F(.*?)&!';
	preg_match($pathMatch, $data["hostprofileurl"], $matches);
	$hostid = $matches[1];
	$data["hostprofileurl"] = 'https://plus.google.com/u/0/'.$hostid;


//die (var_export($data,1));

	return $data;	
}
function changeNotification( $body ) { 

	$data = array();

	// Get the text elements. 
	$dateMatch = '!(Today|Mon|Tue|Wed|Thu|Fri|Sat|Sun), [0-9]{1,2} [A-Z][a-z]*, [0-9]{2}:[0-9]{2} [A-Za-z]*!';
	preg_match( $dateMatch,$body, $match );
	$data["datetime"] = $match[0];

	// Now the elements that are hyperlinked
	$linksMatch = '!<a[^>]*href="(.*?)".*?>(.*?)</a>!';
	preg_match_all( $linksMatch,$body, $match );

	$temp = $match[1][0]; // Event name is linked
	$eventPathMatch = '!path=%2Fevents%2F(.*?)%!';
	preg_match($eventPathMatch, $temp, $matches);
	$data["eventid"] = $matches[1];


//	die(var_export($data,1));

	return $data;
}
function createPageContent( $data ) {
	global $doubleNL;
	
	$rValue = "~~NOCACHE~~". $doubleNL;
	
	$rValue .= "====== ".$data[eventname]." ======";
	$rValue .= $doubleNL;
	$rValue .= "Date Time: <datetime>". $doubleNL;
	$rValue .= "Event Host: <eventhostname>". $doubleNL;
	$rValue .= "Type: <eventtype>". $doubleNL;
	$rValue .= "Event: <eventlink>". $doubleNL;
	$rValue .= "<eventdescription>". $doubleNL;

//	$rValue .= "Event ID: <eventid>". $doubleNL;
//	$rValue .= "Event Name: <eventname>". $doubleNL;
//	$rValue .= "Event Host Profile URL: <hostprofileurl>". $doubleNL;
//	$rValue .= $doubleNL;
//	$rValue .= $doubleNL;


	$rValue .= $doubleNL;


//	$rValue .= "=== Raw Data (Please Ignore) ===".$doubleNL;
//	foreach ($data as $key => $value) {
//			$rValue .= "**".$key."** :  ".$value.$doubleNL;
//	}

	return $rValue;
	
}


function _mysql($Server,$User,$Pass,$Database,$Query){
 	global $doubleNL;
 
	if(!$connection = mysql_connect($Server, $User, $Pass) or false)
		  throw new Exception(mysql_error());
	 
	mysql_select_db($Database, $connection);
 error_log("_mysql query = ".$Query.$doubleNL, 3, "/var/tmp/mail2page.error.log"); 
	$rs = mysql_query($Query);
	$dbArray = array();
 error_log("_mysql rs = ".$rs.$doubleNL, 3, "/var/tmp/mail2page.error.log"); 

	
	if($rs === true) {
	  $dbArray[] = mysql_affected_rows ($connection);
//die(var_export($dbArray));
	} else if ($rs === false) {
		// return empty array	
	} else {
	  while ($row = mysql_fetch_assoc($rs)) {
	    $dbArray[] = $row;
	  }
	}
	 
//die(var_export($dbArray,1));	 
	mysql_close($connection);
	
	return $dbArray;
 
}

function insertData($htmlArray) {
	
	// Convert date / time into MYSQL
	$dt = new DateTime($htmlArray['datetime']);
//echo $htmlArray['datetime']."\n\n".$dt->format( 'Y-m-d H:i:s  e  I  O  T' )."\n\n";
	$tz = new DateTimeZone('GMT');
	$dt->setTimeZone($tz);
//echo $htmlArray['datetime']."\n\n".$dt->format( 'Y-m-d H:i:s  e  I  O  T' )."\n\n";
	
	$sql = 'INSERT INTO Events (eventid,eventlink,datetime,eventname,eventdescription,eventhostname,hostprofileurl) VALUES ';
	$sql .= ' ( ';
	$sql .=  '"'.$htmlArray['eventid'].'", ';
	$sql .=  '"'.$htmlArray['eventlink'].'", ';
	$sql .=  '"'.$dt->format( 'Y-m-d H:i:s e' ).'", ';
	$sql .=  '"'.$htmlArray['eventname'].'", ';
	$sql .=  '"'.$htmlArray['eventdescription'].'", ';
	$sql .=  '"'.$htmlArray['eventhostname'].'", ';
	$sql .=  '"'.$htmlArray['hostprofileurl'].'" ';
	$sql .= ' ) ';
	
//die($sql);
	
	_mysql("localhost", "indieplusDW", "indieplusDW", "indieplus", $sql);
	
}

function updateData($htmlArray) {
	
	// Convert date / time into MYSQL
	$dt = new DateTime($htmlArray['datetime']);
//echo $htmlArray['datetime']."\n\n".$dt->format( 'Y-m-d H:i:s  e  I  O  T' )."\n\n";
	$tz = new DateTimeZone('GMT');
	$dt->setTimeZone($tz);
//echo $htmlArray['datetime']."\n\n".$dt->format( 'Y-m-d H:i:s  e  I  O  T' )."\n\n";
	
	$sql = 'UPDATE Events SET datetime="'.$dt->format( 'Y-m-d H:i:s e' ).'" ';
	$sql .= ' WHERE eventid="'.$htmlArray['eventid'].'"; ';
	
//die($sql);
	
	_mysql("localhost", "indieplusDW", "indieplusDW", "indieplus", $sql);
	
}

function addPage( $ID, $htmlArray ) {
	global $doubleNL;
                                                                                                                  
	require_once(DOKU_INC.'inc/init.php');                                                                                           
	 
	$client = new IXR_Client('http://indieplus.org/lib/exe/xmlrpc.php');
//	$client->debug = 1; // enable for debugging
	$ok = $client->query('dokuwiki.login','gplusnotification','gplusnotification');
	if ( $ok ) {
		$ok = $client->query('wiki.putPage',$ID,createPageContent($htmlArray),'Created by mail2page', false);
//		error_log("XMLRPG putPage : ".$ok.$doubleNL, 3, "/var/tmp/mail2page.error.log"); 
	} else {
		error_log("XMLRPG Login failed : ".$ok.$doubleNL, 3, "/var/tmp/mail2page.error.log"); 			
		die(8);
	}
}
?>