<?php
/**
 * DokuWiki Plugin indieplus (Syntax Component)
 *
 * @license GPL 2 http://www.gnu.org/licenses/gpl-2.0.html
 * @author  Chris Tregenza <chris@6d6firball.com>
 */

// must be run within Dokuwiki
if (!defined('DOKU_INC')) die();

if (!defined('DOKU_LF')) define('DOKU_LF', "\n");
if (!defined('DOKU_TAB')) define('DOKU_TAB', "\t");
if (!defined('DOKU_PLUGIN')) define('DOKU_PLUGIN',DOKU_INC.'lib/plugins/');

require_once DOKU_PLUGIN.'syntax.php';

class syntax_plugin_indieplus extends DokuWiki_Syntax_Plugin {
    public function getType() {
        return 'substition';
    }

    public function getPType() {
        return 'normal';
    }

    public function getSort() {
        return 1234;
    }


    public function connectTo($mode) {
        $this->Lexer->addSpecialPattern('@@INDIEPLUS@@',$mode,'plugin_indieplus');
//        $this->Lexer->addEntryPattern('<FIXME>',$mode,'plugin_indieplus');
    }

//    public function postConnect() {
//        $this->Lexer->addExitPattern('</FIXME>','plugin_indieplus');
//    }

    public function handle($match, $state, $pos, &$handler){
        $data = array();

        return $data;
    }

    public function render($mode, &$renderer, $data) {
        if($mode != 'xhtml') return false;

		$renderer->doc .= $this->calTest();

        return true;
    }
    
    function calTest() {
    	
		require_once 'google-api-php-client/src/apiClient.php';
		require_once 'google-api-php-client/src/contrib/apiPlusService.php';
		
		// Set your cached access token. Remember to replace $_SESSION with a
		// real database or memcached.
		session_start();
		
		$client = new apiClient();
		$client->setApplicationName('IndiePlus');
		// Visit https://code.google.com/apis/console?api=plus to generate your
		// client id, client secret, and to register your redirect uri.
		$client->setClientId('633023247472.apps.googleusercontent.com');
		$client->setClientSecret('4w3ipMy2v8Vp1Zq4HJ2piVjP');
		$client->setRedirectUri('http://indieplus.org/oauth2callback');
		$client->setDeveloperKey('insert_your_simple_api_key');
		$plus = new apiPlusService($client);
		
		if (isset($_GET['code'])) {
		  $client->authenticate();
		  $_SESSION['token'] = $client->getAccessToken();
		  header('Location: http://' . $_SERVER['HTTP_HOST'] . $_SERVER['PHP_SELF']);
		}
		
		if (isset($_SESSION['token'])) {
		  $client->setAccessToken($_SESSION['token']);
		}
		
		if ($client->getAccessToken()) {
		  $activities = $plus->activities->listActivities('me', 'public');
		  return 'Your Activities: <pre>' . print_r($activities, true) . '</pre>';
		
		  // We're not done yet. Remember to update the cached access token.
		  // Remember to replace $_SESSION with a real database or memcached.
		  $_SESSION['token'] = $client->getAccessToken();
		} else {
		  $authUrl = $client->createAuthUrl();
		  return "<a href='$authUrl'>Connect Me!</a>";
		}    	
		    	
    	
    }
    
}

// vim:ts=4:sw=4:et:
